package main

import (
	"vultras.su/core/types/objects"
	"vultras.su/core/types"
	"encoding/json"
	"log"
	"fmt"
)

func main() {
	errPrint := func(err error) {
		if err != nil {
			log.Println(err)
		}
	}
	bobik, err := objects.New[Dog](DogParams{
		Name: "Bobik",
	})
	errPrint(err)
	log.Println("name:", bobik.Name())

	nameless, err := objects.New[Dog](DogParams{
	})
	errPrint(err)
	log.Println("name:", nameless.Name())

	valid := types.Valid(1234)
	nilVal := types.Nil[int]()
	s := struct{
		ValidValue, NilValue types.Nilable[int]
	}{
		valid, nilVal,
	}

	fmt.Println("nillable:", valid, nilVal)
	bts, err := json.MarshalIndent(s, "", "\t")
	if err != nil {
		panic(err)
	}
	fmt.Println(string(bts))
	s.ValidValue = types.Valid(13)
	s.NilValue = types.Valid(75353)

	err = json.Unmarshal(bts, &s)
	if err != nil {
		panic(err)
	}
	fmt.Println(s)
}

