package objects

// Create new object and return pointer to it.
func New[
	O any,
	Params any,
	OP interface{*O; Constructor[Params]},
](
	params Params,
) (OP, error) {

	var buf O
	op := OP(&buf)

	err := op.Construct(params)
	if err != nil {
		return op, err
	}

	return op, nil
}

func Delete(
	object Destructor,
) error {
	err := object.Destruct()
	if err != nil {
		return err
	}
	return nil
}

